---
layout: mockup
title: "VPN"
theme: Adwaita/Adwaita.css
permalink: settings/network/vpn/
wallpaper: adwaita
category: "Network"
---

<!-- css -->
<link rel="stylesheet" type="text/css" href="{{ site.baseurl }}/css/Adwaita/apps/settings.css">

{%- include widgets/_panel.html -%}

<!-- Window -->
<div class="window medium">
	<!-- Titlebar -->
	<div class="titlebar paned">
		<div class="button-group pane float-left">
			<a class="button image-button secondaryButton" href="{{ site.baseurl }}/settings/network">{%- include symbolic/actions/go-previous-symbolic.svg -%}</a>
			<a class="button image-button primaryButton" href="{{ site.baseurl }}/settings/network">{%- include symbolic/actions/go-previous-symbolic.svg -%}</a>
			<span class="title">{{ page.category }}</span>
		</div>
		<a class="button text-button primaryButton float-left" onclick="$('#networkVPNNewConnection').show();">New</a>
		<a class="button text-button secondaryButton float-right" onclick="$('#networkVPNNewConnection').show();">New</a>
		<!-- Title -->
		<div class="title-group">
			<span class="title">{{ page.title }}</span>
		</div>
		<div class="button-group float-right">
			{%- include components/close-button.html close = "window" -%}
		</div>
	</div>
	<!-- Content -->
	<div class="content">
		<!-- Sidebar -->
		<ul id="settingsNetworkSidebar" class="sidebar">
		{%- for item in site.data.settings-alt-network -%}<a href="{{ site.baseurl }}/settings{{ item.link }}"><li>{%- include symbolic/{{ item.icon }}-symbolic.svg -%}<span>{{ item.title }}</span></li></a>{%- if item.has-separator == true -%}<div class="separator"></div>{%- endif -%}{%- endfor -%}
		</ul>
		<!-- View -->
		<div class="view">
			<!-- VPN Details -->
			<div class="row VPNOptionsRow" id="VPNDetails">
				<ul class="listrow">
					<li class="medium">
						<div class="label-group">
							<label>VPN Provider 1</label>
							<label class="dim-label small-label">OpenVPN</label>
						</div>
						<a class="button image-button circular float-right"  onclick="$('#VPNSettingsDialog').show();">{% include symbolic/categories/applications-system-symbolic.svg %}</a>
						{%- include components/switch.html checked="checked" float = "right" id = "VPNSwitch" -%}
					</li>
					<li class="medium">
						<div class="label-group">
							<label>VPN Provider 2</label>
							<label class="dim-label small-label">L2TP</label>
						</div>
						<a class="button image-button circular float-right"  onclick="$('#VPNSettingsDialog').show();">{% include symbolic/categories/applications-system-symbolic.svg %}</a>
						{%- include components/switch.html checked="" float = "right" id = "VPNSwitch2" -%}	

					</li>
				</ul>
			</div>
			{%- include components/empty-state.html
				id = "VPNNotSetUp"
				icon="status/network-vpn" 
				title = "VPN not Set Up" 
				message= "Add or configure a new VPN connection by clicking 'New'." 
			-%}
			{%- include components/empty-state.html
				id = "VPNDisabled"
				icon="status/network-offline" 
				title = "VPN is turned off" 
				message= "Turn on to make and receive calls and use mobile broadband." 
			-%}
		</div>
	</div>
	<!-- Network Settings Dialog -->
	<div class="gtkdialog" id="VPNSettingsDialog">
		<div class="gtkdialog-window large">
			<div class="titlebar grouped">
				<div class="button-group float-left">
					<a class="button image-button secondaryButton" onclick="$('#VPNSettingsDialog').hide();">{%- include symbolic/actions/go-previous-symbolic.svg -%}</a>
					<a class="button text-button hide-on-mobile" onclick="$('#VPNSettingsDialog').hide();">Cancel</a>
				</div>
				<div class="title-group">
					<span class="title">VPN Settings</span>
				</div>
				<div class="button-group float-right">
					<a class="button text-button suggested-action" id="networkSettingsApply" onclick="$('#VPNSettingsDialog').hide();">Apply</a>
				</div>
			</div>
			<div class="gtkdialog-content">
				<!-- Row -->
				<div class="row">
					<ul class="listrow nohover">
						<li onclick="$('#VPNSettingsDialog').hide();$('#VPNProviderNameDialog').show();">
							<label>Connection Name</label>
							{%- include components/listrow-link-icon.html -%}
							<label class="float-right" id="vpnProviderLabel">VPN Provider 1</label>
						</li>
						<li>
							<label>Last Used</label>
							<label class="float-right dim-label">12 August 2019</label>
						</li>
					</ul>
				</div>
				<!-- Row -->
				<div class="row">
					<ul class="listrow">
						<li onclick="toggleChecked('#vpnConnectAutomaticallySwitch');">
							<label>Connect automatically</label>
							{%- include components/switch.html float = "right" checked = "checked" id = "vpnConnectAutomaticallySwitch" -%}
						</li>
						<li onclick="toggleChecked('#vpnAvailableSwitch');">
							<label>Available to others</label>
							{%- include components/switch.html float = "right" checked = "" id = "vpnAvailableSwitch" -%}
						</li>
					</ul>
				</div>
				<!-- Row -->
				<div id="VPNNetworkAdvanced" class="row">
					<h5>Advanced Settings</h5>
					<ul class="listrow">
						<!-- <li onclick="$('#VPNSettingsDialog').hide();$('#VPNIdentityDialog').show();"> -->
						<li>
							<label>Identity & Authentication</label>
							{%- include components/listrow-link-icon.html -%}
							<label class="float-right dim-label">Certificates (TLS)</label>
						</li>
						<li>
							<label>IPv4</label>
							{%- include components/listrow-link-icon.html -%}
							<label class="float-right dim-label">72.95.8.51</label>
						</li>
						<li>
							<label>IPv6</label>
							{%- include components/listrow-link-icon.html -%}
							<label class="float-right dim-label">2001:0db8:85a3:0000</label>
						</li>
					</ul>
				</div>
				<!-- Row -->
				<div class="row">
					<ul class="listrow">
						<li class="text-center">
							<label class="center destructive-action" id="">Remove This Connection</label>
						</li>
					</ul>
				</div>
			</div>
		</div>
	</div>
	<!-- VPN Connection Name Dialog -->
	<div class="gtkdialog" id="VPNProviderNameDialog">
		<div class="gtkdialog-window mobile action-dialog">
			<div class="titlebar" title="VPN Connection Name">
				<a class="button text-button float-left" onclick="$('#VPNProviderNameDialog').hide();$('#VPNSettingsDialog').show();">Cancel</a>
				<a class="button text-button suggested-action float-right" id="vpnProviderName"  onclick="$('#VPNProviderNameDialog').hide();$('#VPNSettingsDialog').show();">Apply</a>
			</div>
			<div class="gtkdialog-content">
				<div class="row">
					<p>Choose a new name for this VPN connection</p>
					<ul class="listrow unstyled">
						<li>
							<input class="entry full-width" value="VPN Provider 1" id="vpnConnectionName"></input>
						</li>
					</ul>
				</div>
			</div>
		</div>
	</div>
	<!-- VPN Identity Dialog -->
	<div class="gtkdialog" id="VPNIdentityDialog">
		<div class="gtkdialog-window options-dialog">
			<div class="titlebar" title="VPN Authentication">
				<a class="button text-button float-left" onclick="$('#VPNIdentityDialog').hide();$('#VPNSettingsDialog').show();">Cancel</a>
				<a class="button text-button float-right hidden"></a>
			</div>
			<div class="gtkdialog-content">
				<!-- Row -->
				<div class="row">
					<h4>Identity</h4>
					<ul class="listrow">
						<li>
							<label>Gateway</label>
							{%- include components/listrow-link-icon.html -%}
							<label class="float-right">the.vpnprovider.com:1198</label>
						</li>
					</ul>
				</div>
				<!-- Row -->
				<div class="row">
					<h4>Authentication</h4>
					<ul class="listrow">
						<li id="vpnSecurityPopover">
							<label>Security</label>
							<div class="icon s16 float-right">{%- include symbolic/actions/dropdown-symbolic.svg -%}</div>
							<label class="float-right" id="vpnSecurityTypeStatus">Certificates (TLS)</label>
						</li>
						<li id="vpnSecurityCACert">
							<label>CA Certificate</label>
							<a class="button text-button float-right">ca.rsa.2048.crt</a>
						</li>
						<li id="vpnSecurityUserCert">
							<label>User Certificate</label>
							<a class="button text-button float-right">(None)</a>
						</li>
						<li id="vpnSecurityPrivateKey">
							<label>Private Key</label>
							<a class="button text-button float-right">(None)</a>
						</li>
						<li id="vpnSecurityPassword">
							<label>Private Key Password</label>
							<div data-toggle="collapse" data-target="#showPassword" class="dropdown button image-button flat float-right" id="revealPassword" onclick="$('#revealPassword > .symbolic:nth-child(1)').toggle();$('#revealPassword > .symbolic:nth-child(2)').toggle();">{%- include symbolic/actions/view-reveal-symbolic.svg -%}{%- include symbolic/actions/view-conceal-symbolic.svg -%}</div>
							<label class="float-right dim-label">&bull;&bull;&bull;&bull;&bull;&bull;&bull;&bull;</label>
						</li>
						<div id="showPassword" class="collapse" aria-expanded="false">
							<ul class="listrow borderless text-center">
								<li>
									<label class="bold-label monospace">phxMcP8GoBU8hpQ3hHJbfpP4</label>
								</li>
							</ul>
						</div>
					</ul>
				</div>
			</div>
		</div>
	</div>
	<!-- Network New VPN Dialog -->
	<div class="gtkdialog" id="networkVPNNewConnection">
		<div class="gtkdialog-window options-dialog">
			<div class="titlebar" title="Add VPN">
				<a class="button text-button float-left" onclick="$('.gtkdialog').hide();">Cancel</a>
				<a class="button text-button float-right hidden"></a>
			</div>
			<div class="gtkdialog-content">
				<div id="vpnTypeList" class="row">
					<ul class="listrow">
						<li class="medium" onclick="$('#networkVPNNewConnection').hide();$('#VPNNotSetUp').hide();$('.VPNOptionsRow').show();">
							<div class="label-group">
								<label>Layer 2 Tunnelling Protocol (L2TP)</label>
								<label class="small-label dim-label">Compatible with Microsoft and other L2TP servers.</label>
							</div>
						</li>
						<li class="medium" onclick="$('#networkVPNNewConnection').hide();$('#VPNNotSetUp').hide();$('.VPNOptionsRow').show();">
							<div class="label-group">
								<label>Cisco AnyConnect Compatible VPN (openconnect)</label>
								<label class="small-label dim-label">Compatible with Cisco AnyConnect SSL VPN.</label>
							</div>
						</li>
						<li class="medium" onclick="$('#networkVPNNewConnection').hide();$('#VPNNotSetUp').hide();$('.VPNOptionsRow').show();">
							<div class="label-group">
								<label>OpenVPN</label>
								<label class="small-label dim-label">Compatible with OpenVPN servers.</label>
							</div>
						</li>
						<li class="medium" onclick="$('#networkVPNNewConnection').hide();$('#VPNNotSetUp').hide();$('.VPNOptionsRow').show();">
							<div class="label-group">
								<label>Point-to-Point Tunnelling Protocol (PPTP)</label>
								<label class="small-label dim-label">Compatible with Microsoft and other PPTP servers.</label>
							</div>
						</li>
						<li class="medium" onclick="$('#networkVPNNewConnection').hide();$('#VPNNotSetUp').hide();$('.VPNOptionsRow').show();">
							<div class="label-group">
								<label>Secure Shell (SSH)</label>
								<label class="small-label dim-label">Compatible with SSH servers.</label>
							</div>
						</li>
						<li class="medium" onclick="$('#networkVPNNewConnection').hide();$('#VPNNotSetUp').hide();$('.VPNOptionsRow').show();">
							<div class="label-group">
								<label>Cisco Compatible VPN (vpnc)</label>
								<label class="small-label dim-label">Compatible with Cisco, Juniper, Netscreen, and Sonicwall IPsec-based VPN gateways.</label>
							</div>
						</li>
						<li class="medium text-center" onclick="$('#networkVPNNewConnection').hide();$('#VPNNotSetUp').hide();$('.VPNOptionsRow').show();">
							<label>Import VPN configuration...</label>
						</li>
					</ul>
				</div>
			</div>
		</div>
	</div>
</div>

<!-- js -->
<script type="text/javascript">
// highlight sidebar
$(document).ready(function() {$('#settingsNetworkSidebar a:nth-of-type(4) li').addClass("active");});

// VPN toggle
$('#VPNSwitch').change(function(){
	if($(this).is(":checked")) {
		$('#statusVPN').show();
	} else {
		$('#statusVPN').hide();
	}
});

$('#VPNDisabled').hide();
$('#VPNNotSetUp').hide();


// fill popover use &apos; to quote escape
$(document).ready(function() {
	var label = "";
	var popoverContent = ['<ul>',
			'<li onclick="popoverVPNSecurity($(this).text());popoverVPNSecurityTLS();">Certificates (TLS)</li>',
			'<li onclick="popoverVPNSecurity($(this).text());popoverVPNSecurityPassword();">Password</li>',
			'<li onclick="popoverVPNSecurity($(this).text());popoverVPNSecurityPasswordWithTLS();">Password with Certificates (TLS)</li>',
			'<li onclick="popoverVPNSecurity($(this).text());popoverVPNSecurityStaticKey();">Static Key</li>',
		'</ul>'].join('');

	$("#vpnSecurityPopover").popover({
		trigger: 'click',
		content: popoverContent,
		placement: "bottom",
		html: true
	});
});

$('#revealPassword > .symbolic:nth-child(2)').hide();

function popoverVPNSecurity() {
	$('#vpnSecurityTypeStatus').text(arguments[0]);
	$("#vpnSecurityPopover").popover("hide");
}

function popoverVPNSecurityTLS() {
	$("#vpnSecurityAuthentication").show();
	$("#vpnSecurityKey").show();
	$("#vpnSecurityIdentity").hide();
	$("#vpnSecurityPrivateKey").show();
	$("#vpnSecurityPrivateKeyPassword").hide();
	$("#vpnSecurityCerts").hide();
	$("#vpnSecurityUsername").hide();
	$("#vpnSecurityPassword").hide();
}

function popoverVPNSecurityPassword() {
	$("#vpnSecurityAuthentication").hide();
	$("#vpnSecurityKey").hide();
	$("#vpnSecurityIdentity").hide();
	$("#vpnSecurityPrivateKey").hide();
	$("#vpnSecurityPrivateKeyPassword").hide();
	$("#vpnSecurityCerts").hide();
	$("#vpnSecurityUsername").show();
	$("#vpnSecurityPassword").show();
}

function popoverVPNSecurityStaticKey() {
	$("#vpnSecurityAuthentication").hide();
	$("#vpnSecurityKey").hide();
	$("#vpnSecurityIdentity").hide();
	$("#vpnSecurityPrivateKey").hide();
	$("#vpnSecurityPrivateKeyPassword").hide();
	$("#vpnSecurityCerts").hide();
	$("#vpnSecurityUsername").show();
	$("#vpnSecurityPassword").show();
}

$("#vpnSecurityAuthentication").hide();
$("#vpnSecurityNoneWarning").hide();
$("#vpnSecurityKey").hide();
$("#vpnSecurityIdentity").hide();
$("#vpnSecurityPrivateKey").show();
$("#vpnSecurityPrivateKeyPassword").hide();
$("#vpnSecurityCerts").hide();
$("#vpnSecurityUsername").hide();
</script>